jQuery(function ($) {
	var loading = false;
	var inputString = 'https://www.youtube.com/user/asmrgarden/feed'.replace(/&quot;/ig, ' ');

	function truncate(str, maxlength, end) {
		end = end == undefined ? '<a href="javascript:void(0)">...</a>' : end;
		if (str.length > maxlength) {
			return str.slice(0, maxlength - 3) + end;
		}
		return str;
	}

	function getDataByString(arr, str) {
		var keys = str.split('.');
		var tmp;
		tmp = arr;
		for (var i = 0; i < keys.length; i++) {
			if (tmp[keys[i]] == undefined) {
				return '';
			}
			else {
				tmp = tmp[keys[i]];
			}
		}
		return tmp;
	}


	function loadVideos(startIndex) {
		if(!startIndex) startIndex = 1;
		loading = true;
		var url = '';

		if (/\/user\/(.*?)(\?.*)?.*/.test(inputString)) {
			var channel = inputString
				.replace(/(.*?)\?.*/, '$1')
				.replace(/.*\/user\/(.*?)/, '$1')
				.replace(/(.*?)\/.*/, '$1');
			url = 'https://gdata.youtube.com/feeds/api/users/' + encodeURIComponent(channel) + '/uploads?v=2&alt=jsonc&max-results=10&start-index='+startIndex
		} else if (/playlist.*?\?.*?list=([A-Za-z0-9_]+(&|$))/i.test(inputString)) {
			var playlist = inputString.match(/playlist.*?\?.*?list=([A-Za-z0-9_]+(&|$))/i)[1];
			url = 'https://gdata.youtube.com/feeds/api/playlists/' + encodeURIComponent(playlist) + '?v=2&alt=jsonc&max-results=10&start-index='+startIndex
		} else {
			url = 'https://gdata.youtube.com/feeds/api/videos?q=' + encodeURIComponent(inputString) + '&v=2&alt=jsonc&max-results=10&start-index='+startIndex;
		}

		var item_template =
			'<a href="https://m.youtube.com/watch?v={{id}}" class="collection-item" >' +
			'<img class="thumb" src="{{thumbnail.mqDefault}}">' +
			'<span class="title"> {{title}}</span>' +
			'<span class="badge">Views: {{viewCount}}</span></a>';
		/*          var item_template = '<li>' +
		 '<div class="preview">' +
		 '<a href="https://www.youtube.com/watch?v={{id}}" title="{{title}}">' +
		 '<img src="{{thumbnail.mqDefault}}" alt="{{title}}"  />' +
		 '</a>' +
		 '</div>' +
		 '<div class="intro"><a href="https://m.youtube.com/#/watch?v={{id}}">{{title}}</a></div>' +
		 '<div class="description">' +
		 '<img src="data:image/gif;base64,R0lGODlhAQABAIAAAP///////yH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" class="Comments" /> <span>{{commentCount}}</span>  ' +
		 '<img src="data:image/gif;base64,R0lGODlhAQABAIAAAP///////yH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" class="Like" /> <span>{{likeCount}}</span>  ' +
		 '<img src="data:image/gif;base64,R0lGODlhAQABAIAAAP///////yH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" class="Views" /> <span>{{viewCount}}</span>' +
		 '</div>' +
		 '<div class="clear"></div> ' +
		 '<div class="full-text">' +
		 '<span class="small">{{small_description}}</span>' +
		 '<div class="full">{{description}}</div>' +
		 '</div>' +
		 '</li>';*/

		$.ajax({
			method:'GET',
			url:url,
			dataType:'jsonp',
			success:function(json){
				loading = false;
				var html = '';
				if(json.error){
					console.error(json.error.message);
				}
				if (json["data"] != undefined && json["data"]["items"] != undefined) {

					$.each(json["data"]["items"], function (i) {
						var el = json["data"]["items"][i];
						if (!el["description"] && !el["title"] && el["video"]) {
							el = el["video"];
						}
						el["small_description"] = truncate(el["description"], 60);
						//el["title"] = truncate(el["title"], 40, "...");
						el.thumbnail.mqDefault = 'http://img.youtube.com/vi/' + el.id + '/mqdefault.jpg';
						el.viewCount = numeral(el.viewCount).format('0a');
						html += item_template.replace(/{{(.*?)}}/ig, function (k, s) {
							return getDataByString(el, s);
						})
					});
					if(startIndex == 0){
						$(".videos-collection").html(html);
					} else {
						$(".videos-collection").append(html);
					}
				} else {
					if(json.data && startIndex > json.data.totalItems){
						$('.loader').hide();
					} else {
						alert("Connection error!");
					}
				}
			},
			error: function(e){
				alert("Connection error!");
			}

		});
	}
	loadVideos();
	$('#refresh-videos').click(function (e) {
		$('.loader').show();
		e.preventDefault();
		$(".videos-collection").html('');
		loadVideos();
	});

	$(window).scroll(function() {
		if($(window).scrollTop() + $(window).height() > $(document).height() - 100) {
			if(!loading){
				loadVideos($('.videos-collection .collection-item').length + 1);
			}
		}
	});
});